.\"	$NetBSD: dosboot.8,v 1.19 2009/03/11 19:26:09 joerg Exp $
.\"
.\" Copyright (c) 1997
.\" 	Matthias Drochner.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)boot_i386.8	8.2 (Berkeley) 4/19/94
.\"
.Dd October 13, 2008
.Dt DOSBOOT 8 i386
.Os
.Sh NAME
.Nm dosboot
.Nd boot NetBSD/i386 from DOS
.Sh SYNOPSIS
.Nm
.Op Fl u
.Op Fl c Ar command
.Op Fl i
.Op Ar path Op Fl adqsv
.Sh DESCRIPTION
.Nm
is an
.Tn MS-DOS
program.
It is a boot loader for
.Nx Ns Tn /i386
designed to permit
.Nx
to be booted directly from
.Tn MS-DOS .
By default, it boots a file with name
.Pa NETBSD
in the current
.Tn MS-DOS
directory.
.Nm
shares common code with the standard boot loader,
.Xr boot 8 .
.Pp
The recognized options are:
.Bl -tag -width -ads -offset 04n
.It Fl c
Execute
.Ar command
(see below).
.It Fl i
Enter interactive mode.
.Nm
will present a prompt, allowing input of commands (see below).
.It Fl u
Boot from a UFS filesystem instead of an
.Tn MS-DOS
filesystem.
.It Ar path
Specifies the kernel file.
In
.Tn MS-DOS
mode (default) a normal
.Tn MS-DOS
filename (with or without drive specification) is accepted.
In UFS mode (after
.Fl u
or after a
.Ic mode ufs
command), a path in a
.Nx
filesystem is expected.
By default, the file is looked up in partition
.Sq a
of the first harddisk.
Another device or partition can be specified
by prepending a block device name in terms of
.Nx ,
followed by a colon (see
.Xr boot 8
and examples).
.It Fl adqsv
Flags passed to the kernel, see
.Xr boot 8 .
.El
.Pp
The commands accepted after the
.Fl c
flag or in interactive mode are:
.\" NOTE: some of this text is duplicated in the MI boot.8
.\" and in other i386-specific *boot.8 files;
.\" please try to keep all relevant files synchronized.
.Bl -tag -width 04n -offset 04n
.It Ic boot Oo Va device : Ns Oc Oo Va filename Oc Oo Fl 1234abcdmqsvxz Oc
Boot
.Nx .
See
.Cm boot
in
.Xr boot 8
for full details.
.It Ic dev Op device
Set the default device and partition for subsequent filesystem operations.
Without an operand, print the current setting.
This setting doesn't apply to
.Tn MS-DOS
mode.
.It Ic help
Print an overview about commands and arguments.
.It Ic ls Op Pa path
Print a directory listing of
.Pa path ,
containing inode number, filename and file type.
This command works in UFS mode only.
.Pa path
can contain a device specification.
.It Ic mode Va fstype
Switch filesystem type;
.Va fstype
should be one of
.Ar dos
or
.Ar ufs .
.It Ic quit
Leave the
.Nm
program and exit to
.Tn MS-DOS .
.El
.Pp
.Nm
is also installed in the
.Xr release 7
hierarchy, under
.Pa installation/misc/dosboot.com .
.Sh FILES
.Pa /usr/mdec/dosboot.com
.Sh EXAMPLES
To boot a
.Nx
kernel located on
.Tn MS-DOS
drive D, one would issue:
.Bd -literal -offset indent
dosboot D:\eNODOS\eNETBSD
.Ed
.Pp
To boot from a
.Nx
floppy into single user mode, type e.g.:
.Bd -literal -offset indent
dosboot -u fd0a:netbsd -s
.Ed
.Sh SEE ALSO
.Xr release 7 ,
.Xr boot 8 ,
.Xr w95boot 8
.Sh HISTORY
The
.Nx Ns Tn /i386
.Nm
command first appeared in
.Nx 1.3 .
.Sh BUGS
.Nm
assumes that the processor is in real mode at startup.
It does not work well in the presence of
.Tn MS-DOS
extenders and memory managers.
.Pp
.Nm
does not run directly under
.Tn Windows 95 .
See
.Xr w95boot 8
for a method of starting
.Nx
from
.Tn Windows 95
using dosboot.
.Pp
In UFS mode, files can only be loaded from devices known to the BIOS.
The device names do not necessarily comply with the names later
used by the booted
.Nx
kernel.
.Pp
In
.Tn MS-DOS
mode, no useful boot device specification is passed to
.Nx .
It is necessary to have the root device hardwired into the kernel
configuration or to enter it manually.
